//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "registry.hpp"

#include "InstallForm.h"
//---------------------------------------------------------------------------
#pragma link "Blend"
#pragma link "Mystd"
#pragma link "zAnimate"
#pragma link "Blend"
#pragma link "Mystd"
#pragma link "Mystd"
#pragma link "EsLabel"
#pragma link "EsMarque"
#pragma resource "*.dfm"
TEEInstallForm *EEInstallForm;
//---------------------------------------------------------------------------
__fastcall TEEInstallForm::TEEInstallForm(TComponent* Owner)
  : TForm(Owner)
{ 
}
//---------------------------------------------------------------------------
void __fastcall TEEInstallForm::InstallBtnClick(TObject *Sender)
{ 
  if ( InstallCBuilder10->Checked )
  { // Do the cbuilder dance
    Register( "C++Builder\\1.0", CreateKey );
  }
  if ( InstallCBuilder30->Checked )
  { // Do the cbuilder dance
    Register( "C++Builder\\3.0", CreateKey );
  }
  if ( InstallCBuilder40->Checked )
  { // Do the cbuilder dance
    Register( "C++Builder\\4.0", CreateKey );
  }
  if ( InstallDelphi10->Checked )
  { // Do the cbuilder dance
    Register( "Delphi\\1.0", CreateKey );
  }
  if ( InstallDelphi20->Checked )
  { // Do the cbuilder dance
    Register( "Delphi\\2.0", CreateKey );
  }
  if ( InstallDelphi30->Checked )
  { // Do the cbuilder dance
    Register( "Delphi\\3.0", CreateKey );
  }
  if ( InstallDelphi40->Checked )
  { // Do the cbuilder dance
    Register( "Delphi\\4.0", CreateKey );
  }

  Close();
}
//---------------------------------------------------------------------------
bool TEEInstallForm::Register( char* pkey, RegisterAction what )
{
	TRegistry* reg = new TRegistry;

  AnsiString key("\\Software\\Borland\\");

  key += pkey;
  key += "\\Experts";

  if ( what == CreateKey )
  { // then create a new key
    if ( reg->OpenKey( key, true ) )
    { // got the key, add a value
      AnsiString curdir = Application->ExeName;
      int pathdlm = curdir.LastDelimiter( "\\" );
      AnsiString keyval = curdir.SubString(1, pathdlm) + "ee.dll";
      reg->WriteString( EMACSEDIT_VALUE_NAME, keyval);
    }
  }
  else if ( what == DeleteKey )
  {  // find it and remove it
    if ( reg->OpenKey( key, false ) )
    { // okay, it's there, get rid of it
      reg->DeleteValue( EMACSEDIT_VALUE_NAME );
    }
  }
  else if ( what == FindKey )
  { // return true if key is there
    return (reg->OpenKey( key, false ) && reg->ValueExists( EMACSEDIT_VALUE_NAME ));
  }

  return true;
}
//---------------------------------------------------------------------------
void __fastcall TEEInstallForm::CancelBtnClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TEEInstallForm::UninstallBtnClick(TObject *Sender)
{
  if ( InstallCBuilder10->Checked )
  { // Do the cbuilder dance
    Register( "C++Builder\\1.0", DeleteKey );
  }

  if ( InstallCBuilder30->Checked )
  { // Do the cbuilder 3.0 dance
    Register( "C++Builder\\3.0", DeleteKey );
  }

  if ( InstallCBuilder40->Checked )
  { // Do the cbuilder 3.0 dance
    Register( "C++Builder\\4.0", DeleteKey );
  }

  if ( InstallDelphi10->Checked )
  { // Do the cbuilder dance
    Register( "Delphi\\1.0", DeleteKey ); 
  }
  if ( InstallDelphi20->Checked )
  { // Do the cbuilder dance
    Register( "Delphi\\2.0", DeleteKey );
  }
  if ( InstallDelphi30->Checked )
  { // Do the cbuilder dance
    Register( "Delphi\\3.0", DeleteKey );
  }
  if ( InstallDelphi40->Checked )
  { // Do the cbuilder dance
    Register( "Delphi\\4.0", DeleteKey );
  }

  Close();
}
//---------------------------------------------------------------------------
void __fastcall TEEInstallForm::FormCreate(TObject *Sender)
{
  InstallCBuilder10->Checked = Register( "C++Builder\\1.0", FindKey );
  InstallCBuilder30->Checked = Register( "C++Builder\\3.0", FindKey );
  InstallCBuilder40->Checked = Register( "C++Builder\\4.0", FindKey );
  InstallDelphi10->Checked = Register( "Delphi\\1.0", FindKey );
  InstallDelphi20->Checked = Register( "Delphi\\2.0", FindKey );
  InstallDelphi30->Checked = Register( "Delphi\\3.0", FindKey );
  InstallDelphi40->Checked = Register( "Delphi\\4.0", FindKey );

  if (InstallCBuilder10->Checked || InstallCBuilder30->Checked ||
      InstallDelphi10->Checked || InstallDelphi20->Checked ||
      InstallDelphi30->Checked || InstallDelphi30->Checked || InstallCBuilder40->Checked )
  { // enable deinstall
    UninstallBtn->Enabled = true;
  }
  else
    UninstallBtn->Enabled = false;

} 
//---------------------------------------------------------------------------



