//---------------------------------------------------------------------------
#ifndef InstallFormH
#define InstallFormH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include "zAnimate.hpp"
#include <vcl\ComCtrls.hpp>
#include "Blend.hpp"
#include "MyStd.hpp"
#include "Mystd.hpp"
#include "EsLabel.hpp"
#include "EsMarque.hpp"
//---------------------------------------------------------------------------

enum RegisterAction { CreateKey, DeleteKey, FindKey };

class TEEInstallForm : public TForm 
{    
__published:	// IDE-managed Components 
  TzNWBlendPaint *zNWBlendPaint1;
  TPanel *Panel1;
  TCheckBox *InstallCBuilder10;
  TCheckBox *InstallDelphi10;
  TCheckBox *InstallDelphi20;
  TCheckBox *InstallDelphi30;
  TzBitColBtn *InstallBtn;
  TzTitleBar *zTitleBar1;
  TMemo *Memo1;
  TzBitColBtn *CancelBtn;
  TzBitColBtn *UninstallBtn;
  TzHint *zHint1;
  TCheckBox *InstallCBuilder30;
    TCheckBox *InstallCBuilder40;
    TEsLabel *EsLabel1;
    TCheckBox *InstallDelphi40;
  void __fastcall InstallBtnClick(TObject *Sender);




  void __fastcall CancelBtnClick(TObject *Sender);
  void __fastcall UninstallBtnClick(TObject *Sender);
  void __fastcall FormCreate(TObject *Sender);
  
  
  
private:	// User declarations
public:		// User declarations
  __fastcall TEEInstallForm(TComponent* Owner);
  bool Register( char* key, RegisterAction what );

};

#define EMACSEDIT_VALUE_NAME "EmacsEdit"
//---------------------------------------------------------------------------
extern TEEInstallForm *EEInstallForm;
//---------------------------------------------------------------------------
#endif
